﻿class ScrambleTextField extends MovieClip {

	public var _text:String; 
	public var _tf:TextField; 
	public var _intervallo:Number = 100; 
	public var _int:Number; 
	private var _pos:Number; 
	private var _apos:Number; 
	public var _tline:MovieClip; 
	public var _head:String = ""; 
	
	private var characters:Array = new Array("A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", ",", "!", "?", " "); 
	
	public function ScrambleTextField() {
		shuffle(characters); 
	}
	
	private function shuffle(arr:Array):Void {
	   for(var i=0;i<arr.length;i++){
		  var tmp=arr[i];
		  var randomNum=random(arr.length);
		  this[i]=arr[randomNum];
		  this[randomNum]=tmp;
	   }		
	}
	
	public function begin():Void {
		_tf.text = ""; 
		_int = setInterval(loop, 0.2, this); 
		_head = ""; 
		_pos = 0; 
		_apos = 0; 
	}
	
	public function end():Void {
		_text = ""; 
		clearInterval(_int); 
	}
	
	public function set interval (inter:Number) {
		_intervallo = inter; 
	}
	
	public function set text (testo:String):Void {
		_text = testo; 
	}
	
	public function loop(mc:MovieClip):Void {

		if (mc._pos >= mc._text.length) {
			
			mc.end();
			
		} else {
		
			var dest:String = (String(mc._text).charAt(mc._pos)); 
			if (mc._apos >= mc.characters.length || mc._apos > 5) {
				var currchar:String = dest; 
			} else {
				var currchar:String = mc.characters[mc._apos]; 
			}
			mc._tf.text = mc._head + currchar;
			
			if (currchar == dest || mc.charcters[mc._apos+1] == dest) {
				mc._head += dest; 
				mc._pos += 1; 
				mc._apos = 0; 
			} else {
				mc._apos += 2;
			}
		
		}
		
	}
	
}